#include "bullet.hh"
#include "explosion.hh"
#include "bat.hh"
#include "game.hh"


extern Explosions explo;
extern Bat bat;
extern int rocket;
extern Game game;

Bullet::Bullet()
{
}


Bullet::~Bullet()
{
}


void Bullet::CheckBrick(int sx,int sy)
{
  int br = Brick(sx,sy);
  int b = brick[br];
  
  if (brix[b].strength==5 && brix[b].changeTo!=0)
    ChangeBrick(br,brix[b].changeTo);
  else
    if (stat==0)
      {
	if (brix[b].strength==1)
	  ChangeBrick(br,brix[b].changeTo);
      }
    else
      if (brix[b].strength<5 && brix[b].strength>0)
	{
	  if (brix[b].changeTo!=0)
	    {
	      int start=b;
	      b=brick[br]=brix[b].changeTo;
	      while(brix[b].changeTo!=0 && b!=start)
		b=brick[br]=brix[b].changeTo;
	    }
	  ChangeBrick(br,brix[b].changeTo);
	}
 }


void Bullet::Update()
{
  if (stat == 0 || stat == 2)
    {
      if (stat == 2)
	speed+=0.05;
      y -= speed;
   
      int br = Brick(x,int(y));
      int b = brick[br];
      if (brix[b].strength>0)
	{
	  int tempX = int(x/BRICK_WIDTH)*BRICK_WIDTH;
	  int tempY = int(y/BRICK_HEIGHT)*BRICK_HEIGHT;
	  explo.Add(tempX,tempY+BRICK_HEIGHT);
	  pw_rop((Xv_opaque)pw, x, int(y+speed), 12, 28, 
		 PIX_SRC, poBack.pr, x, int(y+speed));
	  CheckBrick(tempX,tempY);
	  if (stat == 2)
	    {
	      if (game.sound==1) audio.Play(16);
	      CheckBrick(tempX+BRICK_WIDTH,tempY);
	      CheckBrick(tempX-BRICK_WIDTH,tempY);
	      if (br>GAME_WIDTH*2)
		CheckBrick(tempX,tempY-BRICK_HEIGHT);
	    }
	  stat=-1;
	}
      else
	{
	  Draw();
	}
    }
  else
    {
      x = bat.x + bat.w/2-5;
      y = bat.y - 28;
      if (mouseButton == 1)
	{
	  mouseButton = 0;
	  stat = 2;
	  game.rocket = 0;
	}
      Draw();
    }
}   




void Bullet::Draw()
{
  if (oldx != x || oldy != y)
    {
      pw_rop((Xv_opaque)pw, oldx, oldy, 12, 28, 
	     PIX_SRC, poBack.pr, oldx,oldy);
      oldx = int(x);
      oldy = int(y);
    }
  pw_rop((Xv_opaque)pw, x, int(y), 12, 28, 
	 PIX_SRC, poBullet.pr, stat*12,0);
}



Bullets::Bullets()
{
  counter = 0;
  for (int t=0; t<3 ;t++)
    bu[t].stat = -1;
}



Bullets::~Bullets()
{
}



int Bullets::Add(int x, int y, int stat,int speed)
{
  if (bu[counter].stat==-1)
    {
      bu[counter].stat = stat;
      bu[counter].x = bu[counter].oldx = x;
      bu[counter].y = bu[counter].oldy = y;
      bu[counter].speed = speed;
      counter = (counter + 1)%3;
      return 0;
    }
  return 1;
}
  


void Bullets::Update()
{
  static int firecount=0;
  if (firecount>0)
    firecount--;
  else
    if (mouseButton == 1 && game.numberOfBullets>0)
      {
	firecount=20;
	mouseButton = 0;
	if (Add(bat.x+bat.w/2-5,bat.y-28,0,12)==0 && game.sound==1) 
	  {
	    game.numberOfBullets--;
	    audio.Play(17);
	  }
	if (game.numberOfBullets == 0)
	  {
	    bat.stat = 0;
	    bat.w = BAT_WIDTH;
	    bat.size = 2;
	    bat.h = BAT_HEIGHT;
	  }
      }
  for (int t = 0;t < 3;t++)
    if (bu[t].stat > -1)
      {
	bu[t].Update();
      }
}
   
 


void Bullets:: DeleteAll()
{
  counter = 0;
  for (int t=0; t<3 ;t++)
    if (  bu[t].stat != -1)
      {
	bu[t].stat = -1;
	//pw_rop((Xv_opaque)pw, bu[t].oldx,bu[t].oldy, 12, 28, 
	//       PIX_SRC, poBack.pr, bu[t].oldx,bu[t].oldy);
      }
}






