#include <string.h>
#include "effect.hh"
#include "bat.hh"
#include "explosion.hh"
#include "audio.hh"
#include "game.hh"
#include "highscore.hh"
#include "level.hh"

extern Bat bat;
extern Explosions explo;
extern Audio audio;
extern Game game;
extern double Sin[360], Cos[360];
extern Highscore highScores;
extern World world;
extern struct properties props;
extern void killframe();

Pixobj poGud;


Effect::Effect()
{
  poButtons.Load("gfx/button.ras");
  poKeso.Load("gfx/keso.ras");
  poKo.Load("gfx/ko.ras");
  poBest.Load("gfx/best.ras");
  poNed.Load("gfx/undertext.ras");
}


Effect::~Effect()
{
}

void Effect::PutBat()
{
  SetMouse((GAME_WIDTH*BRICK_WIDTH)/2,mouseY);
  bat.x = Limit((mouseX-(GAME_WIDTH*BRICK_WIDTH/4))*2,BRICK_WIDTH,
		(GAME_WIDTH-1)*BRICK_WIDTH-bat.w);
  int x = bat.x;
  int y = bat.y;
  int size = 0;
  int w = 20;
  int t;
  for (t=0;t<5;t++)
    {
      int xpos = x-(w-BAT_WIDTH)/2;
      if (xpos<0) xpos=0;
      pw_rop((Xv_opaque)pw, xpos, y, w, BAT_HEIGHT,
	     PIX_SRC, poBat.pr,
	     0, size*BAT_HEIGHT);
      
      w += BAT_WIDTH;
      size++;
      if (size == 1)
	w = 32;
      if (size == 2)
	w = BAT_WIDTH;
      Hold(3);

    }
  for (t=0;t<4;t++)
    {
      int xpos = x-(w-BAT_WIDTH)/2;
      if (xpos<0) xpos=0;
      pw_rop((Xv_opaque)pw, xpos, y, w, BAT_HEIGHT,
	     PIX_SRC, poBat.pr,
	     0, size*BAT_HEIGHT);   
      Hold(3);

      pw_rop((Xv_opaque)pw, xpos, y, w, BAT_HEIGHT,
	     PIX_SRC, poBack.pr,
	     xpos, y);
      w -= BAT_WIDTH;
      size--;
    }
}

void Effect::ArlaIn()
{
  pw_rop((Xv_opaque)pw, (GAME_WIDTH*BRICK_WIDTH-694)/2, 25, 
	 poArla.prWidth(), poArla.prHeight(),
	 PIX_SRC, poArla.pr, 0, 0);

/* for (int x=1;x<304;x+=30)
  {
    pw_rop((Xv_opaque)pw,50,50,x+50,186,
	   PIX_SRC,poArla.pr,303-x,0);
    pw_rop((Xv_opaque)pw,705-x,50,x,186,
	   PIX_SRC,poArla.pr,353,0);
    Hold(1);
  }
*/
}


void Effect::Intro()
{

 
  poGud.Load("gfx/gud.ras");
  ShowXY(poBack, 0, 0, PIX_CLR);

  ArlaIn();
  x = 0;

  for (int y = 0; y < 30; y++)
  {
    pw_rop((Xv_opaque)pw, 0, 274, GAME_WIDTH*BRICK_WIDTH,  
	   2, PIX_SRC, poFire.pr, 0, 60-y);
    pw_rop((Xv_opaque)pw, 0, 576, GAME_WIDTH*BRICK_WIDTH, 
	   2, PIX_SRC, poFire.pr, 0, y);
    Hold(2);
  }

  pw_rop((Xv_opaque)pw, 40,735,poNed.prWidth(),poNed.prHeight(),PIX_SRC,
	 poNed.pr,0,0);
  ShowXY(poGud, (GAME_WIDTH*BRICK_WIDTH-64)/2, 620);

  int s=0;

  char *sent[] = {"- t e a m  k e s $ -",
		  "     presenterar",
		  "",
		  "      arlanoid",
		  " -the besta spelet!",
		  "",
		  "  knackat och m[lat",
		  "          av",
		  "   danster / bepp",
		  "",
		  " sn]lla pojkar som",
		  "  hj]lprunat vid",
		  "   h[rda ;gonblick,",
		  "  m[lat loss eller",
		  "    aggerat som",
		  " moraliskt st;d",
		  "",
		  "      hipp", 
		  "mastodontfilmsm]ts",
		  "       teddy",
		  " signe granat",
		  "    mats atari",             
		  "        coq",             
		  "      ugha",             
		  "       kefir",             
		  "",             
		  " alla ljud ]r",             
		  "  himmaluade och",
		  " inga undulater",
		  "   skadades",             
		  " under k[dningen..",             
		  "",             
		  "",             
		  "buggar kan hj]rtligt",
		  "  mejlas till",
		  "    /dev/null",             
		  "", 
		  "   parfymerade",
		  "k]rleksbrev [ andra",
		  "   sidan till",
		  "pt93da@pt.hk-r.se",
		  "       eller",
		  "  pt93jr@pt.hk-r.se",
		  "",             
		  "   keso rox i",             
		  "  hallonlandet..",             
		  "",             
		  "    yeah...",             
		  "",             
		  "    (c) 1995",
		  "",
		  " ...p[ cola x2 och", 
		  "   stora baggets", 
		  "   snickrade hos",
		  "      bepp..",
		  "",             
		  "",             
		  "",             
		  "",  
		  "",             
		  "",             
		  NULL};
  int se = 0; 
  for (int sents = 0; sent[sents]!=NULL; sents++);

//  int sents = 22;

  InitScroll(sent,sents,100,276,510,300);
 /* double ax = 2;
  for (double t=100;t<400;t+=ax)
    {
      poPict.Op(PIX_SET).Vector(int(t),0,int(t),400);
      if (t>250)
	ax-=0.1;
      else
	ax+=0.1;
    }*/
  for (int t=100;t<400;t+=2)
    poPict.Op(PIX_SET).Vector(int(t),0,int(t),400);

  while(mouseButton == 0)
    {
      ScrollFullDown(2);
      Hold(1);
    }
  mouseButton = 0;
  poBack << PIX_CLR;
  ShowXY(poBack, 0, 276);
}



void Effect :: InitMainMenu()
{
  poPict << PIX_CLR;
  pw_rop((Xv_opaque)pw, 0, 274, GAME_WIDTH*BRICK_WIDTH,  
	 2, PIX_SRC, poPict.pr, 0, 0);
  mouseButton = 0;

  char* buttonText[]={"rokka loss",
		      "",
		      "kvitt"};
  char* so[]={"soundet off",
	      "soundet on"};
  buttonText[1]=so[game.sound];
  int numButts = 3;
  int x = 225;
  int y = 350;
  int wi = 70;

  ShowXY(poKo, 150,250);

  pw_rop((Xv_opaque)pw, 40,735,poNed.prWidth(),poNed.prHeight(),PIX_SRC,
	 poNed.pr,0,0);

  for (int c=0;c<numButts;c++)
    {
      pw_rop((Xv_opaque)pw,x,y+c*wi,350,60,
	     PIX_SRC,poButtons.pr,0,0);
      PrintWinText(buttonText[c], x+(350-strlen(buttonText[c])*30)/2,y+c*wi+10);
    }
  int button = 1;
  SetMouse(mouseX,y+10);
  while (mouseButton == 0)
    {
      if (mouseY<y) SetMouse(mouseX,y+10);
      if (mouseY>y+numButts*50) SetMouse(mouseX,y+numButts*50-10);
      int nb = Limit((mouseY-y) / 50,0,2);
   
      if (nb!=button)
	{
	  pw_rop((Xv_opaque)pw,x,y+button*wi,350,60,
		 PIX_SRC,poButtons.pr,0,0);
	  PrintWinText(buttonText[button], x+(350-strlen(buttonText[button])*30)/2,
		       y+button*wi+14);
	  pw_rop((Xv_opaque)pw,x,y+nb*wi,350,60,
		 PIX_SRC,poButtons.pr,0,60);
	  PrintWinText(buttonText[nb], x+(350-strlen(buttonText[nb])*30)/2,
		       y+nb*wi+17);
	  button = nb;
	}
      Hold(1);
      if (mouseButton==1)
	{
	  if (button==1)
	    {
	     
	      game.sound = 1-game.sound;
	      buttonText[button]=so[game.sound];
	      pw_rop((Xv_opaque)pw,x,y+button*wi,350,60,
		     PIX_SRC,poButtons.pr,0,60);
	      PrintWinText(buttonText[button], 
			   x+(350-strlen(buttonText[button])*30)/2,
			   y+button*wi+17);
	      mouseButton = 0;
	    }
	  else
	    if (button==2)
	      {
		system("xset r on");
		exit(0);
	      }
	}
    }
  FadeOut();
}




void Effect::ViewHiscoreList()
{
  char str[7];
  
  char **sctext = new char*[SCORES+6];
  for (int i = 0; i < SCORES+6; i++)
    sctext[i] = new char[NAMELEN*2]; 
  for (int t = 0; t < SCORES;t++)
    {
      sprintf(sctext[t], "%02d. %s", t+1, highScores.hs[t].name);
      for (int k = strlen(sctext[t]); k < NAMELEN+4; k++)
	sctext[t][k] = ' ';
      sctext[t][k] = '\0';
      sprintf(str, " %02d", highScores.hs[t].level+1);
      strcat(sctext[t], str);
      sprintf(str, " %06d", highScores.hs[t].score);
      strcat(sctext[t], str);
    }
  strcpy(sctext[t++], ".........................");

  int xpos = (GAME_WIDTH*BRICK_WIDTH-poBest.prWidth())/2;
 
  for (y = 1; y < poBest.prHeight(); y+=3)
    {
      pw_rop((Xv_opaque)pw, xpos, 0, poBest.prWidth(),  
	     y, PIX_SRC, poBest.pr,0, poBest.prHeight()-y);
    }
   for (int y = 0; y < 30; y++)
    {
      pw_rop((Xv_opaque)pw, 0, 328, GAME_WIDTH*BRICK_WIDTH,  
	     2, PIX_SRC, poFire.pr, 0, 60-y);
      pw_rop((Xv_opaque)pw, 0, 610, GAME_WIDTH*BRICK_WIDTH, 
	     2, PIX_SRC, poFire.pr, 0, y);
      Hold(2);
    }
  pw_rop((Xv_opaque)pw, 40,735,poNed.prWidth(),poNed.prHeight(),PIX_SRC,
	 poNed.pr,0,0);
  ShowXY(poGud, (GAME_WIDTH*BRICK_WIDTH-64)/2, 620);
  

  InitScroll(sctext,SCORES+1,55,330,660,280);
  poBack.Op(PIX_SRC).Rect(55,20,
			  poKeso.prWidth(),poKeso.prHeight()) = 
			    poKeso.X(0).Y(0);
  world.GetProperties(&props);
  PrintWinText(props.n,360-(strlen(props.n)/2)*(30-5),250,-5);

  while(mouseButton == 0)
    {
      ScrollDown(2);
      Hold(1);
    }
}




void Effect::InitGlobe(int gsize)
{
  for (int t=0;t<NUMBER_OF_PIXELS;t++)
    {
      degx[t]=random()%360;
      degy[t]=random()%360;
    }
  deg = 0;
  size = gsize;
}

void Effect::SpinGlobe(int x,int y)
{ 
  pw_rop((Xv_opaque)pw,x,y,size*2,size*2,PIX_NOT(PIX_SRC)&PIX_DST,poBack.pr,0,0);
  poBack.Rect(0,0,size*2,size*2) = PIX_CLR;
 
  for (int gr=0;gr<NUMBER_OF_PIXELS;gr++)
    {
      int xpos=int(Sin[(degx[gr]+deg)%360]*(Sin[(degy[gr])%360]*size)+size);
      int ypos=int(Cos[degy[gr]]*size+size);
      poBack.Op(PIX_SET).Vector(xpos,ypos,xpos+1,ypos);
      //poBack.Vector(xpos,ypos+1,xpos+1,ypos+1);
    }

  deg+=3;
  pw_rop((Xv_opaque)pw,x,y,size*2,size*2,PIX_SRC|PIX_DST,poBack.pr,0,0);
}



void Effect::InitScroll(char** te,int srows,int sx,int sy, int swidth, int sheight)
{
  text = te;
  x = sx;
  y = sy;
  height = sheight;
  width = swidth;
  row = 0;
  co = 0;
  rows = srows;
  poBack.Rect(0,0,width,height+70) = PIX_CLR;
  poPict.Rect(0,0,width,height+70) = PIX_CLR;
  startgr=0;
}

/*
void Effect :: ScrollDown(int speed)
{
  if (co<0)
    {
      PrintText(text[row],poBack,0,height+35,-4);
      row = (row+1)%rows;
      co = 35;
    }
  co-=speed;
  
  poBack.Op(PIX_SRC).Rect(0,0,width,height+70-speed) = poBack.X(0).Y(speed);
  pw_rop((Xv_opaque)pw,x,y,width,height,
	 PIX_SRC,poBack.pr,0,35);
}
}*/



void Effect :: ScrollDown(int speed)
{
  if (co<0)
    {
      PrintText(text[row],poPict,0,height,-4);
      row = (row+1)%rows;
      co = 35;
    }
  co-=speed;
  poPict.Op(PIX_SRC).Rect(0,0,width,height+35) = poPict.X(0).Y(speed);
  int gr = startgr;
  for (int t=0;t<height;t+=2)
    {
      poBack.Op(PIX_SRC).Rect(int(Sin[gr]*10)+10,t,width,1)=
	     poPict.X(0).Y(t);
      gr = (gr+6)%360;
    }
  pw_rop((Xv_opaque)pw,x,y,width,height,
	 PIX_SRC,poBack.pr,0,0);
  startgr = (startgr+15)%360;
}


void Effect :: ScrollFullDown(int speed)
{
  if (co<0)
  {
    PrintText(text[row],poPict,0,height,-4);
    ++row%=rows;
    co = 35;
  }
  co -= speed;
  poPict.Op(PIX_SRC).Rect(0,0,width,height+35) = poPict.X(0).Y(speed);
  int gr = startgr;
  for (int t=0;t<height;t+=3)
  {
    poBack.Op(PIX_SRC).Rect(int(Sin[gr]*10)+10,t,width,3)=
      poPict.X(0).Y(t);
    gr = (gr+4)%360;
  }
  pw_rop((Xv_opaque)pw,x,y,width,height,
	 PIX_SRC,poBack.pr,0,0);
  startgr = (startgr+6)%360;
}




void Effect :: ScrollUp(int speed)
{
  if (co>35)
    {
      PrintText(text[row],poBack,0,0,-4);
      if (row>0) row -= 1;
      co = 0;
    }
  co+=speed;
  
  poBack.Op(PIX_SRC).Rect(0,speed,width,height+70-speed) = poBack.X(0).Y(0);
  pw_rop((Xv_opaque)pw,x,y,width,height,
	 PIX_SRC,poBack.pr,0,35);
}


void Effect::PanelUp()
{
  if (game.sound==1) audio.Play(20);
  for (int y = 5; y < BRICK_HEIGHT*4; y += 5)
    ShowXY(poPanel, 0, (GAME_HEIGHT+2)*BRICK_HEIGHT-y);
  ShowXY(poPanel, 0, (GAME_HEIGHT-2)*BRICK_HEIGHT);
}





void Effect::LevelIn()
{
  int br[GAME_WIDTH*(GAME_HEIGHT-2)];
  for (int b=0;b<GAME_WIDTH*(GAME_HEIGHT-2);b++)
    br[b]=0;
  int num = GAME_WIDTH*(GAME_HEIGHT-2);
  while(num>0)
    {
      int t=5;
      while (t>0 && num>0)
	{
	  b=random()%(GAME_WIDTH*(GAME_HEIGHT-2));
	  while(br[b]==1)
	    b=(b+1)%(GAME_WIDTH*(GAME_HEIGHT-2));
	  br[b]=1;
	  num--;
	  t--;
	  pw_rop((Xv_opaque)pw,(b%GAME_WIDTH)*BRICK_WIDTH,
		 int(b/GAME_WIDTH)*BRICK_HEIGHT,
		 BRICK_WIDTH,BRICK_HEIGHT,PIX_SRC, poBack.pr,
		 (b%GAME_WIDTH)*BRICK_WIDTH,int(b/GAME_WIDTH)*BRICK_HEIGHT);
	}
      Hold(1);
    }
}






void Effect::FadeOut(int x1=0,int y1=0,int x2=GAME_WIDTH*BRICK_WIDTH,
	     int y2=(GAME_HEIGHT+2)*BRICK_HEIGHT)
{
  int y = y1;
  while(y<y2)
    {
      int t=30;
      while(t>0 && y<y2)
	{
	  y+=2;
	  t--;
	  pw_vector((Xv_opaque)pw,x1,y,x2,y,PIX_CLR,0);
	  pw_vector((Xv_opaque)pw,x1,int((y2-y1)/2)*2-y+1,
		    x2,int((y2-y1)/2)*2-y+1,PIX_CLR,0);
	}
      Hold(1);
    }
}



void Effect::UpdateScore()
{
  static int oldscore = 1;
  char str[7];
  
  if (game.score != oldscore)
  {
    sprintf(str, "%06d", game.score);
    for (int k = 0; k < 6; k++)
    {
      pw_rop((Xv_opaque)pw, 45+k*38+k*5, (GAME_HEIGHT-1)*BRICK_HEIGHT-8,
	     38, 69, PIX_SRC, poFont.pr, (int(str[k])-48)*38+(int(str[k])-48)*1, 0);
    }
  }
  oldscore = game.score;
}








void Effect::UpdateLife()
{
  pw_rop((Xv_opaque)pw, 350, (GAME_HEIGHT-2)*BRICK_HEIGHT+20, 150, 20,
  	 PIX_SRC, poPanel.pr, 350, 20);

  for (int k = 0; k < game.life && k < 5; k++)
    pw_rop((Xv_opaque)pw, 350+k*30, (GAME_HEIGHT-2)*BRICK_HEIGHT+20, 20, 20,
	   PIX_SRC, poKrafs.pr, 0, 0);
}






void Effect::UpdateTime(int n)
{
  char str[6];
  
  sprintf(str, "%04d", n);
  for (int k = 0; k < 4; k++)
  {
    pw_rop((Xv_opaque)pw, 529+k*(11+2), GAME_HEIGHT*BRICK_HEIGHT-27, 
	   12, 15, PIX_SRC, po11x14.pr, (int(str[k])-48)*12, 0);
  }
}




void Effect::PrintText(char* text ,Pixobj &pix ,int x ,int y, int space = 0, int op = PIX_SRC|PIX_DST)
{
  static int width = 29;
  static int height = 35;
  static int inrow = 16;
  int pos = x;
  int len = strlen(text);
  for (int t=0;t<len;t++)
    {
      int b=GetLetter(text[t]);
      pix.Op(op).Rect(pos,y,width,height) = 
	po28x34.X((b%inrow)*(width+1)).Y(int(b/inrow)*(height+1));
      pos += width + space;
    }
}


void Effect::PrintWinText(char* text ,int x ,int y, int space = 0, 
			  int mode=PIX_SRC|PIX_DST)
{
  int width = 29;
  int height = 35;
  int inrow = 16;
  int pos = x;
  int len = strlen(text);
  for (int t=0;t<len;t++)
    {
      int b=GetLetter(text[t]);
      pw_rop((Xv_opaque)pw,pos,y,width,height,
	     mode,po28x34.pr,(b%inrow)*(width+1),
	     int(b/inrow)*(height+1));
      pos += width + space;
    }
}


void Effect::PrintSpecialText(char* text ,int x ,int y, int space = 0)
{
  for (int xr=0;xr<5;xr+=2)
    for (int yr=0;yr<5;yr+=2)
      PrintWinText(text,x+xr,y+yr,space);
  
  PrintWinText(text,x+2,y+2,space,PIX_NOT(PIX_SRC)&PIX_DST);
}

void Effect::UpdateLetters()
{
  for (int k = 0; k < 8; k++)
    pw_rop((Xv_opaque)pw, 345+k*30, GAME_HEIGHT*BRICK_HEIGHT+10, 30, 30,
	   PIX_SRC, poLetter.pr, game.letters[k]%12*31, int(game.letters[k]/12)*31);
}

int Effect::GetLetter(int b)
{ 

  if (b>64 && b<91)
    b-=65;
  else
    if (b>96 && b<124)
      b-=97;
    else
      if (b>47 && b<58)
	b-=16;
      else
	switch (b)
	  {
	  case 32: // 
	    b = 26;
	    break;
	  case 33: // !
	    b = 27;
	    break;
	  case 46: // .
	    b = 28;
	    break;
	  case 63: // ?
	    b = 29;
	    break;
	  case 39: // '
	    b = 30;
	    break;
	  case 34: // "
	    b = 31;
	    break;
	  case 40: // (
	    b = 42;
	    break;
	  case 41: // )
	    b = 43;
	    break;
	  case 42: // *
	    b = 44;
	    break;
	  case 43: // +
	    b = 45;
	    break;
	  case 45: // -
	    b = 46;
	    break;
	  case 44: // ,
	    b = 47;
	    break;
	  case 47: // /
	    b = 48;
	    break;
	  case '[':
	    b = 50;
	    break;
	  case ']':
	    b = 51;
	    break;
	  case ';':
	    b = 52;
	    break;
	  case '$':
	    b = 53;
	    break;
	  case '@':
	    b = 54;
	    break;
	  case '=':
	    b = 55;
	    break;
	  default:
	    b = 26;
	    break;
	  }
  return b;
}
