#include <signal.h>
#include "global.hh"
#include "audio.hh"
#include "ball.hh"
#include "bonus.hh"
#include "game.hh"
#include "explosion.hh"
#include "bat.hh"

extern Audio audio;
extern BallContainer balls;
extern Bonuses bonus;
extern Game game;
extern Explosions explo;
extern Bat bat;
extern int sheet;
Notify_value Clock();

Frame frame;
Canvas canvas;
struct itimerval T;
Pixobj poBall, poBat, poBrick, poBoom, poMask, poLetter;
Pixobj poKrafs, po11x14, po28x34, poSpel, poFire, poArla;
Pixobj poBonus, poBullet, poPanel, poFont;
Pixobj poLogo(BRICK_WIDTH*GAME_WIDTH,BRICK_HEIGHT*(GAME_HEIGHT+2),1);
Pixobj poBack(BRICK_WIDTH*GAME_WIDTH,BRICK_HEIGHT*(GAME_HEIGHT+2),1);
Pixobj poPict(BRICK_WIDTH*GAME_WIDTH,BRICK_HEIGHT*(GAME_HEIGHT+2),1);
Pixwin *pw;

double Sin[360], Cos[360];
uchar brick[GAME_WIDTH*(GAME_HEIGHT+1)];
int keydir = 0, mouseX, mouseY, mouseButton,keyNumber;
int clockCount = 0;
short cursor_bits[] = { 0 };

void segfunc()
{
  fprintf(stderr, "Fel poe Operativsystemet!\n");
  system("xset r on");
  exit(0);
}

void InitWindow(int argc, char **argv)
{
  Server_image svr_image;
  Xv_Cursor cursor;
  
  xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

  svr_image = (Server_image)xv_create(XV_NULL, SERVER_IMAGE,
				      XV_WIDTH, 16,
				      XV_HEIGHT, 1,
				      SERVER_IMAGE_BITS, cursor_bits,
				      NULL);

  cursor = (Xv_Cursor)xv_create(XV_NULL, CURSOR, CURSOR_IMAGE, svr_image, NULL);
 
  frame = (Frame)xv_create((long unsigned int)NULL, FRAME,
			   XV_X, (1152-GAME_WIDTH*BRICK_WIDTH)/2,
			   XV_Y, (900-(GAME_HEIGHT+2)*BRICK_HEIGHT)/2,
			   XV_WIDTH, GAME_WIDTH*BRICK_WIDTH,
			   XV_HEIGHT, (GAME_HEIGHT+2)*BRICK_HEIGHT,
			   XV_LABEL, "Arlanoid  1995 Team Keso",
			   FRAME_SHOW_FOOTER, FALSE,
			   FRAME_SHOW_RESIZE_CORNER, FALSE,
			   NULL);

  canvas = xv_create(frame, CANVAS,
		     XV_X, 0,
		     XV_Y, 0,
	  	     XV_WIDTH, GAME_WIDTH*BRICK_WIDTH,
		     XV_HEIGHT, (GAME_HEIGHT+2)*BRICK_HEIGHT,
		     CANVAS_X_PAINT_WINDOW, TRUE,
		     CANVAS_REPAINT_PROC, repaint,
		     WIN_BORDER, FALSE,
		     NULL);

  pw =  canvas_pixwin(canvas);

  xv_set(canvas_paint_window(canvas),
	 WIN_CURSOR, cursor,
	 WIN_EVENT_PROC, events,
	 WIN_CONSUME_EVENTS, 
	 WIN_ASCII_EVENTS,
	 WIN_MOUSE_BUTTONS,
	 LOC_MOVE,
	 LOC_DRAG,
	 NULL,
	 NULL);
  
  Display* dpy = (Display*) xv_get(frame, XV_DISPLAY);
  XFlush(dpy);
  
  xv_set(frame, XV_SHOW, TRUE, NULL);
  signal(SIGSEGV, segfunc);
  
  XAutoRepeatOff(dpy);

  T.it_value.tv_usec=5000;
  T.it_interval.tv_usec=5000;

  notify_set_itimer_func(frame, Clock, ITIMER_REAL, &T, NULL);
}



void repaint()
{
}

void SetTitle(char *n)
{
  xv_set(frame, XV_LABEL, n, NULL);
}

void events(Xv_Window window, Event *event)
{
  static int ox;
  static int oy;
  mouseButton = 0;
 
  switch(event->ie_xevent->type)
    {
      
    case KeyPress:
      keyNumber = XLookupKeysym(&(event->ie_xevent->xkey), 0);
     
      switch(XLookupKeysym(&(event->ie_xevent->xkey), 0))
	{	     
	case XK_Escape:
	  game.life = -1;
	  game.ballsIn = 0;
	  break;

	case XK_Up:
	  xv_set(frame, XV_Y, xv_get(frame, XV_Y) - 10, NULL);
	  break;

	case XK_Down:
	  xv_set(frame, XV_Y, xv_get(frame, XV_Y) + 10, NULL);
	  break;
	  
	case XK_Left:
	  xv_set(frame, XV_X, xv_get(frame, XV_X) - 10, NULL);
	  break;

	case XK_Right:
	  xv_set(frame, XV_X, xv_get(frame, XV_X) + 10, NULL);
	  break;

	case XK_Shift_R:
	  if (sheet==1) game.finished = 1;
	  break;

	case XK_Shift_L:
	  if (sheet==1)
	    {
	      game.finished = 1;
	      game.level+=4;
	    }
	  break;

	case XK_equal:
	case XK_plus:
	case XK_KP_Add:
	  game.volume+=10;
	  game.sound=1;
	  if (game.volume>255) 
	    game.volume = 255;
	  audio.Volume(game.volume);
	  audio.Play(33);
	  break;

	case XK_minus:
	case XK_KP_Subtract:
	case XK_F24:
	  game.volume-=10;
	  if (game.volume<0) 
	    {
	      game.volume = 0;
	      game.sound=0;
	    }
	  audio.Volume(game.volume);
	  audio.Play(33);
	  break;
	  
	case XK_space:
	  if (game.finished == 0)
	    {
	      Shake();
	      balls.ChangeDir();
	    }
	  break;
	}
      break;

    case KeyRelease:
      switch(XLookupKeysym(&(event->ie_xevent->xkey), 0))
	{	     

	case XK_Left:
	  keydir++;
	  break;
	  
	case XK_Right:
	  keydir--;
	  break;
	}
      break;

      
    case ButtonPress:
      mouseButton = event->ie_xevent->xbutton.button;
      break;

    case ButtonRelease:
      mouseButton = 0;
      break;

    }

  switch(event_action(event))
    {
    case LOC_DRAG:
      mouseButton = event->ie_xevent->xbutton.button;
    case LOC_MOVE:
      mouseX = event_x(event);
      mouseY = event_y(event);
      if (mouseY<150 || mouseY>600)
	SetMouse(mouseX,350);
      break;
    }


}




void SetMouse(int x, int y)
{
  xv_set(frame, WIN_MOUSE_XY, x, y, NULL); 
  mouseX = x;
  mouseY = y;
}





int Limit(int nr,int low, int high)
{
  if (nr > high)
    nr = high;
  if (nr < low)
    nr = low;
  return nr;
}





void RemoveBrick(int x, int y)
{
  x = x/BRICK_WIDTH;
  y = y/BRICK_HEIGHT;
  brick[y*GAME_WIDTH+x] = 0;

  poBack.Op(PIX_SRC).Rect(x*BRICK_WIDTH, y*BRICK_HEIGHT, 
	      BRICK_WIDTH, BRICK_HEIGHT) = 
		poPict.X(x*BRICK_WIDTH).
		  Y(y*BRICK_HEIGHT);
  
  pw_rop((Xv_opaque)pw, x*BRICK_WIDTH, y*BRICK_HEIGHT,
	 BRICK_WIDTH, BRICK_HEIGHT, PIX_SRC,
	 poBack.pr, x*BRICK_WIDTH, y*BRICK_HEIGHT);
}


void RemoveBrick(int br)
{
  int x = (br%GAME_WIDTH)*BRICK_WIDTH;
  int y = int(br/GAME_WIDTH)*BRICK_HEIGHT;
  brick[br] = 0;

  poBack.Op(PIX_SRC).Rect(x, y, BRICK_WIDTH, BRICK_HEIGHT) = 
		poPict.X(x).Y(y);
  
  pw_rop((Xv_opaque)pw, x, y,
	 BRICK_WIDTH, BRICK_HEIGHT, PIX_SRC,
	 poBack.pr, x, y);
}


void SetBrick(int br,int type)
{
  static int x,y;

  x = (br%GAME_WIDTH)*BRICK_WIDTH;
  y = int(br/GAME_WIDTH)*BRICK_HEIGHT;
  brick[br] = type;
  
  if (brix[type].mask!=-1)
    {
      poBack.Op(PIX_SRC).Rect(x, y,BRICK_WIDTH, BRICK_HEIGHT) = 
	poPict.X(x).Y(y);
      poBack.Op(PIX_SRC&PIX_DST).Rect(x, y, BRICK_WIDTH, BRICK_HEIGHT) = 
	  poMask.X((brix[type].mask%10)* BRICK_WIDTH).
	    Y(int(brix[type].mask/10)*BRICK_HEIGHT);
      poBack.Op(PIX_SRC|PIX_DST).Rect(x, y,BRICK_WIDTH, BRICK_HEIGHT) = 
	poBrick.X(brix[type].x).Y(brix[type].y);
    }
  else
    poBack.Op(PIX_SRC).Rect(x, y,BRICK_WIDTH, BRICK_HEIGHT) = 
      poBrick.X(brix[type].x).Y(brix[type].y);
  pw_rop((Xv_opaque)pw, x, y, BRICK_WIDTH, BRICK_HEIGHT, PIX_SRC,
	 poBack.pr, x, y);
}




int Brick(int x, int y)
{
  return (int(y/BRICK_HEIGHT) * GAME_WIDTH) + int(x/BRICK_WIDTH);
}




void InitGraphics()
{
  poBat.Load("gfx/bats.ras");
  poBall.Load("gfx/balls.ras");
  poBrick.Load("gfx/bricks.ras");
  poBonus.Load("gfx/bonus.ras");
  poBullet.Load("gfx/bullet.ras");
  poPanel.Load("gfx/panel.ras");
  poFont.Load("gfx/font.ras");
  poKrafs.Load("gfx/krafs.ras");
  po11x14.Load("gfx/11x14.ras");
  poMask.Load("gfx/mask.ras");
  poArla.Load("gfx/logo.ras");
  po28x34.Load("gfx/28x34.ras");
  poLetter.Load("gfx/letters.ras");
  poBoom.Load("gfx/boom.ras");
  poSpel.Load("gfx/spelover.ras");
  poFire.Load("gfx/firebar.ras");
}


void InitAudio()
{
  audio.Load(0, "blip.au");
  audio.Load(1, "cokeecho.au");
  audio.Load(2, "dannegnissel.au");
  audio.Load(3, "kadunk.au");
  audio.Load(4, "kapsyl.au");
  audio.Load(5, "metal.au");
  audio.Load(6, "scratch.au");
  audio.Load(7, "snigel.au");
  audio.Load(8, "tegelsten.au");
  audio.Load(9, "tryne.au");
  audio.Load(10, "blop.au");
  audio.Load(11, "boing.au");
  audio.Load(12, "dannegarv.au");
  audio.Load(13, "denego.au");
  audio.Load(14, "tssch.au");
  audio.Load(15, "boink1.au");
  audio.Load(16, "raket.au");
  audio.Load(17, "skott.au");
  audio.Load(18, "rautknissel.au");
  audio.Load(19, "vovve.au");
  audio.Load(20, "intro.au");
  audio.Load(21, "a.au");
  audio.Load(22, "b.au");
  audio.Load(23, "e.au");
  audio.Load(24, "p.au");
  audio.Load(25, "r.au");
  audio.Load(26, "k.au");
  audio.Load(27, "s.au");
  audio.Load(28, "l.au");
  audio.Load(29, "o.au");
  audio.Load(30, "i.au");
  audio.Load(31, "ojsandaa.au");
  audio.Load(32, "explo.au");
  audio.Load(33, "dov.au");
  audio.Load(34, "clang.au");
  audio.Load(35, "damdadam.au");
  audio.Load(36, "adebra.au");
  audio.Load(37, "door.au");
  audio.Load(38, "fladdermus.au");
  audio.Load(39, "hajscar.au");
  audio.Load(40, "megarap.au");
  audio.Load(41, "ping.au");
  audio.Load(42, "skratt.au");
  audio.Load(43, "vissel.au");
  audio.Load(44, "rap.au");
  audio.Load(45, "100.au");
  audio.Load(46, "skitbra.au");
  audio.Load(47, "ajajaj.au");
  audio.Load(48, "illa.au");
 
}



void InitMisc()
{
  for (int t = 0; t < 360; t++)
  {
    Sin[t] = sin(t*3.14159265/180);
    Cos[t] = cos(t*3.14159265/180);
  }
}







void Shake()
{
  int x = xv_get(frame, XV_X);
  int y = xv_get(frame, XV_Y);  
  xv_set(frame, XV_X, x-2, NULL);
  xv_set(frame, XV_X, x+2, NULL);
  xv_set(frame, XV_X, x, NULL);
}




Notify_value Clock()
{
  clockCount++;
  return NOTIFY_DONE;
}







void Hold(int times)
{
  while(times > 0)
  {
    times--;
    while (game.oldClock == clockCount)
    {
      notify_dispatch();
    }
    game.oldClock = clockCount;
  }
}






void ChangeBrick(int br,int type)
{
  int letter[]={0,1,4,8,10,11,14,15,17,18};
  int b = brick[br];
  game.score+= brix[b].score;
  
  if (brix[b].bonus!=-1)
    {
      if (brix[b].bonus<10)
	bonus.Add(br%GAME_WIDTH*BRICK_WIDTH,
		  int(br/GAME_WIDTH)*BRICK_HEIGHT,
		  brix[b].bonus);
      else
	bonus.Add(br%GAME_WIDTH*BRICK_WIDTH+15,
		  int(br/GAME_WIDTH)*BRICK_HEIGHT,
		  brix[b].bonus);
    }
  if (brix[b].needed==1)
    game.numbricks--;

  if (type==0)
    {
      int brx = br%GAME_WIDTH*BRICK_WIDTH;
      int bry = int(br/GAME_WIDTH)*BRICK_HEIGHT;
      RemoveBrick(br);
      if (brix[b].explosion==1)
	explo.Add(brx,bry);
      switch (brix[b].special)
	{
	case 1:                        // take key
	  game.keys--;
	  if (game.keys==0)
	    {
	      if (game.sound==1) audio.Play(37);
	      brick[game.door]=2;
	      int bry2 = int(game.door/GAME_WIDTH) * BRICK_HEIGHT;
	      int brx2 = game.door%GAME_WIDTH*BRICK_WIDTH;
	      poBack.Op(PIX_SRC).Rect(brx2, bry2,BRICK_WIDTH, BRICK_HEIGHT) = 
		poPict.X(brx2).Y(bry2);
	      poBack.Op(PIX_SRC&PIX_DST) = poMask.X(BRICK_WIDTH). Y(0);
	      poBack.Op(PIX_SRC|PIX_DST) = poBrick.X(BRICK_WIDTH*2). Y(0);
	      pw_rop((Xv_opaque)pw,brx2,bry2,BRICK_WIDTH,
		     BRICK_HEIGHT, PIX_SRC, poBack.pr,brx2,bry2);
	    }
	  break;
	  
	case 2:                       //  exit reached
	  SetBrick(br,2);
	  game.finished = 1;
	  break;
	  
	case 3:                       // more balls
	  balls.Add(brx + BRICK_WIDTH/2, bry + BRICK_HEIGHT/2, random()%360,
		    random()%3+3,1,0);
	  break;
	  
	case 4:                       // smaller bat
	  if (bat.size>0)
	    {
	      balls.LaunchAll();
	      bat.w -= BAT_WIDTH;
	      bat.size--;
	      if (bat.size == 0)
		bat.w = 20;
	      if (bat.size == 1)
		bat.w = 32;
	    }
	  break;
	  
	case 5:                       // higher speed
	  balls.ChangeSpeed(1);
	  break;
	  
	case 6:                       // get mirror
	  SetMouse(GAME_WIDTH*BRICK_WIDTH-mouseX,
		   GAME_HEIGHT/2*BRICK_HEIGHT);
	  bat.mirror = 1 - bat.mirror;
	  break;

	case 7:
	  if (random()%100>92)
	    if (random()%100>40)
	      bonus.Add(brx,bry,5);
	    else
	      {
		bonus.Add(brx+15,bry,10+letter[random()%10]);
	      }
	  break;

	case 9:                       // even more balls
	  balls.Add(brx + BRICK_WIDTH/2, bry + BRICK_HEIGHT/2, random()%360,
		    random()%3+4,1,0);
	  balls.Add(brx + BRICK_WIDTH/2, bry + BRICK_HEIGHT/2, random()%360,
		    random()%3+4,1,0);
	  break;
	}
    }
  else
    {
      SetBrick(br,type);
    }
}
