#ifndef _global_hh_
#define _global_hh_

#include "pixobj.hh"
#include <pixrect/pr_io.h>
#include <xview/xview.h>
#include <xview/pixwin.h>
#include <xview/canvas.h>
#include <xview/xv_xrect.h>
#include <X11/keysym.h>
#include <xview/cursor.h>
#include <xview/svrimage.h>
#include "audio.hh"
#include "brick.hh"
#include "kesostd.h"

typedef unsigned char uchar;

#define GAME_WIDTH 13
#define GAME_HEIGHT 25
#define BRICK_WIDTH 58
#define BRICK_HEIGHT 28
#define MAX_BALLS 10
#define BREAKABLE 30
#define SPECIALBREAK 20
#define UNBREAKABLE 10

void InitGraphics();	// Load gfxfiles
void InitAudio();	// Load soundfiles
void InitMisc();	// Miscellanous initializations
void SetMouse(int x, int y); // Set mouse
void InitWindow(int argc, char **argv);
void repaint();
void events(Xv_Window window, Event *event);
void RemoveBrick(int x, int y);
void RemoveBrick(int br);
int Brick(int x, int y);
int Limit(int nr,int low, int high);
void Shake();
void Hold(int);
void SetBrick(int br,int type);
void ChangeBrick(int br,int type);

extern Pixobj poBall, poBat, poBrick, poBoom, poKrafs, po11x14, po28x34, poFire;
extern Pixobj poBonus, poBullet, poLogo, poPanel, poFont, poLetter, poSpel;
extern Pixobj poBack, poPict, poMask, poArla;
extern Pixwin *pw;
extern Brick brix[100];

extern uchar brick[GAME_WIDTH*(GAME_HEIGHT+1)];
extern int keydir, mouseX, mouseY, mouseButton, keyNumber;
extern Audio audio;
extern int clockCount;

struct moveable
{
  int br;
  int dir;
  int type;
};
extern moveable move[40];

#endif

















