#include <stdio.h>
#include <string.h>
#include "highscore.hh"
#include <sys/types.h>
#include <sys/stat.h>

void Highscore :: init()
{
  for (int i = 0; i < SCORES; i++)
  {
    strcpy(hs[i].name, "Team Keso");
    strcpy(hs[i].uid, "-");
    hs[i].score = 1000-i*50;
    hs[i].level = 1;
  }
}

Highscore :: Highscore(void)
{
  init();
}


Highscore :: ~Highscore(void)
{
}



int Highscore :: Load(char *f)
{
  char t[255];
  strcpy(t, SCOREDIR);
  strcat(t, f);
  strcat(t, ".hs");

  FILE *fp = fopen(t, "r");

  if (fp == NULL)
    return 0;
  
  for (int i = 0; i < SCORES; i++)
    fread(&hs[i], 1, sizeof(struct hs_node), fp);

  fclose(fp);
  return 1;
}


int Highscore :: Create(char *f)
{
  init();
  Save(f);
}

int Highscore :: Save(char *f)
{
  char t[255];
  strcpy(t, SCOREDIR);
  strcat(t, f);
  strcat(t, ".hs");

  FILE *fp = fopen(t, "w");

  if (fp == NULL)
    return 0;
  
  for (int i = 0; i < SCORES; i++)
    fwrite(&hs[i], 1, sizeof(struct hs_node), fp);

  fclose(fp);
  chmod(t, S_IWUSR|S_IRUSR|S_IWGRP|S_IRGRP|S_IROTH|S_IWOTH);
  return 1;
}

void Highscore :: AddPlayer(struct hs_node *h, int p)
{
//  printf("%d %s %s\n", p-=2, h.name, h.uid);
  strcpy(hs[p].name, h->name);
  strcpy(hs[p].uid, h->uid);
  hs[p].level = h->level;
  hs[p].score = h->score;
}


int Highscore :: GetPos(struct hs_node h)
{
  if ((h.score < score(h.uid)) || (h.uid[0] == '-'))
    return 0;

  int newpos = pos(h.score)-1;
  int oldpos;

  if (score(h.uid)) // if exist
    oldpos = pos(score(h.uid))-1;
  else
    oldpos = SCORES;
  
  for (int l = oldpos; l > newpos; l--)
  {
    strcpy(hs[l].name, hs[l-1].name);
    strcpy(hs[l].uid, hs[l-1].uid);
    hs[l].level = hs[l-1].level;
    hs[l].score = hs[l-1].score;
  }

  strcpy(hs[newpos].name, "");
  strcpy(hs[newpos].uid, h.uid);
  hs[newpos].level = h.level;
  hs[newpos].score = h.score;

  return pos(h.score);
}

int Highscore :: score(char *n)
{
  for (int l = 0; l < SCORES; l++)
    if (!strcmp(hs[l].uid, n) && (n[0] != '-'))
      return hs[l].score;
  return 0;
}

int Highscore :: pos(int s)
{
  for (int l = 0; l < SCORES; l++)
    if (s > hs[l].score)
      return l+1;
  return 0;
}


void Highscore :: Dump()
{
  printf("---------------------------------------------\n");
  printf("Pos UserID             Nick      Level  Score\n");
  printf("---------------------------------------------\n");
  for (int l = 0; l < SCORES; l++)
    printf("%45d\r%38d\r%28s\r%12s\r%02d.\n", hs[l].score, hs[l].level, hs[l].name, hs[l].uid, l+1);
  printf("---------------------------------------------\n");
}

